#include "HelloWorldScene.h"
#include "SimpleAudioEngine.h"

USING_NS_CC;

Scene* HelloWorld::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();
    
    // 'layer' is an autorelease object
    auto layer = HelloWorld::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
    //////////////////////////////
    // 1. super init first
    if ( !Layer::init() )
    {
        return false;
    }
    
    auto visibleSize = Director::getInstance()->getVisibleSize();
    Vec2 origin = Director::getInstance()->getVisibleOrigin();
    
    std::string filename = "HelloWorld.png";
    img = new Image();
    img->initWithImageFile(filename);
    
    CCLOG("%s loaded. Size: %dx%d. Bits per pixel: %d", filename.c_str(), img->getWidth(), img->getHeight(), img->getBitPerPixel());
    
    data = img->getData(); //pixel data
    
    memset(data + img->getDataLen() / 4, 255, img->getDataLen() / 4); //white rectangle
    setColor4B(83, 109, Color4B::RED, data); //single red pixel
    
    texture = new Texture2D();
    texture->initWithImage(img);
    auto sprite = Sprite::createWithTexture(texture);

    sprite->setPosition(Vec2(visibleSize.width/2 + origin.x, visibleSize.height/2 + origin.y));
    addChild(sprite);
    
    setColor4B(85, 109, Color4B::GREEN, data); //single green pixel
    //we have to update texture
//    texture->updateWithData(data, 0, 0, img->getWidth(), img->getHeight()); //here's how to update whole data
    texture->updateWithData(data, 85, 109, 1, 1); //you can also update only part of it to increase performance
    
    return true;
}

void HelloWorld::setColor4B(int x, int y, Color4B color, unsigned char* data){
    int index = (x + y * img->getWidth()) << 2; //the same as * 4
    data[index] = color.r;
    data[index + 1] = color.g;
    data[index + 2] = color.b;
    data[index + 3] = color.a;
}
